package com.njzscloud.supervisory.expense.service;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.supervisory.expense.contant.ExpenseItemCategory;
import com.njzscloud.supervisory.expense.mapper.ExpenseItemsConfigMapper;
import com.njzscloud.supervisory.expense.pojo.entity.ExpenseItemsConfigEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 付费项配置
 */
@Slf4j
@Service
public class ExpenseItemsConfigService extends ServiceImpl<ExpenseItemsConfigMapper, ExpenseItemsConfigEntity> implements IService<ExpenseItemsConfigEntity> {

    /**
     * 新增
     */
    public void add(ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        // expenseItemsConfigEntity.setExpenseItemCategory(ExpenseItemCategory.QingYunFuWuFei.getVal());
        this.save(expenseItemsConfigEntity);
    }

    /**
     * 修改
     */
    public void modify(ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        this.updateById(expenseItemsConfigEntity);
    }

    /**
     * 删除
     */
    @Transactional(rollbackFor = Exception.class)
    public void del(List<Long> ids) {
        this.removeBatchByIds(ids);
    }

    /**
     * 详情
     */
    public ExpenseItemsConfigEntity detail(Long id) {
        return this.getById(id);
    }

    /**
     * 分页查询
     */
    public PageResult<ExpenseItemsConfigEntity> paging(PageParam pageParam, ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        expenseItemsConfigEntity.setDeleted(Boolean.FALSE);
        return PageResult.of(this.page(pageParam.toPage(), Wrappers.query(expenseItemsConfigEntity)));
    }

}
